#! /bin/sh
# Copyright (c) 2002 Dirk Rieger
#
# Author: Dirk Rieger <rieger@hhgoth.de>, 2002
#
# /etc/init.d/dchub
#   and its symbolic link
# /usr/sbin/rcdchub
#
# System startup script for the DirectConnectHub
#
### BEGIN INIT INFO
# Provides:       dchub
# Required-Start: $remote_fs $named $syslog
# Required-Stop:  $remote_fs $named $syslog
# Default-Start:  3 5
# Default-Stop:   0 1 2 6
# Description:    Start Direct Connect Hub
### END INIT INFO

DCHUB_DIR=/usr/local/dchub
DCHUB_BINDIR=$DCHUB_DIR/bin
DCHUB_BIN=$DCHUB_BINDIR/dchub
DCHUB_CONFDIR=$DCHUB_DIR/etc
DCHUB_CONFDB=$DCHUB_CONFDIR/dchub.conf
DCHUB_USERFILE=$DCHUB_CONFDIR/dchub.users
DCHUB_HUBPASSFILE=$DCHUB_CONFDIR/dchub.hubpasswd
DCHUB_CRCFILE=$DCHUB_CONFDIR/dchub.crc
DCHUB_SCRIPTDIR=$DCHUB_DIR/scripts
DCHUB_MAINSCRIPT=main.pl
DCHUB_EXTPROGDIR=$DCHUB_DIR/bots

test -x $DCHUB_BIN || exit 5
test -f $DCHUB_CONFDB || exit 5
test -f $DCHUB_USERFILE || exit 5
test -f $DCHUB_HUBPASSFILE || exit 5
test -d $DCHUB_SCRIPTDIR || exit 5
test -f $DCHUB_SCRIPTDIR/$DCHUB_MAINSCRIPT ||exit 5
test -d $DCHUB_EXTPROGDIR || exit 5

# Shell functions sourced from /etc/rc.status:
#      rc_check         check and set local and overall rc status
#      rc_status        check and set local and overall rc status
#      rc_status -v     ditto but be verbose in local rc status
#      rc_status -v -r  ditto and clear the local rc status
#      rc_failed        set local and overall rc status to failed
#      rc_reset         clear local rc status (overall remains)
#      rc_exit          exit appropriate to overall rc status
. /etc/rc.status

# First reset status of this service
rc_reset

# Return values acc. to LSB for all commands but status:
# 0 - success
# 1 - misc error
# 2 - invalid or excess args
# 3 - unimplemented feature (e.g. reload)
# 4 - insufficient privilege
# 5 - program not installed
# 6 - program not configured
#
# Note that starting an already running service, stopping
# or restarting a not-running service as well as the restart
# with force-reload (in case signalling is not supported) are
# considered a success.

case "$1" in
    start)
	echo -n "Starting DirectConnect HUB"
	## Start daemon with startproc(8). If this fails
	## the echo return value is set appropriate.
	# startproc should return 0, even if service is
	# already running to match LSB spec.
	startproc $DCHUB_BIN -c $DCHUB_CONFDB -u $DCHUB_USERFILE -P $DCHUB_HUBPASSFILE -r $DCHUB_CRCFILE -d $DCHUB_SCRIPTDIR -s $DCHUB_MAINSCRIPT -e $DCHUB_EXTPROGDIR >/dev/null 2>&1
	# startproc $DCHUB_BIN -c $DCHUB_CONFDB -u $DCHUB_USERFILE -d $DCHUB_SCRIPTDIR -s $DCHUB_MAINSCRIPT -e $DCHUB_EXTPROGDIR -f 411

	# Remember status and be verbose
	rc_status -v
	;;
    stop)
	echo -n "Shutting down DirectConnect HUB"
	## Stop daemon with killproc(8) and if this fails
	## set echo the echo return value.

	killproc -TERM $DCHUB_BIN

	# Remember status and be verbose
	rc_status -v
	;;
    try-restart)
	## Stop the service and if this succeeds (i.e. the
	## service was running before), start it again.
	$0 stop  &&  $0 start

	# Remember status and be quiet
	rc_status
	;;
    restart)
	## Stop the service and regardless of whether it was
	## running or not, start it again.
	$0 stop
	$0 start

	# Remember status and be quiet
	rc_status
	;;
    force-reload)
	## Signal the daemon to reload its config. Most daemons
	## do this on signal 1 (SIGHUP).
	## If it does not support it, restart.

	echo -n "Reload service dchub"
	$0 stop
        $0 start
	rc_status

	;;
    reload)
	## Like force-reload, but if daemon does not support
	## signalling, do nothing (!)

	# If it supports signalling:
	echo -n "Reload service dchub"
	killproc -HUP $DCHUB_BIN -c $DCHUB_CONFDB -u $DCHUB_USERFILE -P $DCHUB_HUBPASSFILE -r $DCHUB_CRCFILE -d $DCHUB_SCRIPTDIR -s $DCHUB_MAINSCRIPT -e $DCHUB_EXTPROGDIR
	rc_status -v

	# If it does not support reload:
	# exit 3
	;;
    status)
	echo -n "Checking for dchub: "
	## Check status with checkproc(8), if process is running
	## checkproc will return with exit status 0.

	# Status has a slightly different for the status command:
	# 0 - service running
	# 1 - service dead, but /var/run/  pid  file exists
	# 2 - service dead, but /var/lock/ lock file exists
	# 3 - service not running

	# If checkproc would return LSB compliant ret values,
	# things could be a little bit easier here. This will
	# probably soon be the case ...
	checkproc $DCHUB_BIN; rc=$?
	if test $rc = 0; then echo "OK"
	else echo "No process"
	fi
	#rc_status
	;;
    *)
	echo "Usage: $0 {start|stop|status|try-restart|restart|force-reload|reload}"
	exit 1
	;;
esac
rc_exit
